 \NeedsTeXFormat{LaTeX2e}
 \ProvidesClass{ProjectReport}%[V 1.0,December 2020, SGU]

% Allow the inclusion of graphics
\ifx\pdfoutput\undefined
% we are running LaTeX, not pdflatex
\usepackage{graphicx}
\else
% we are running pdflatex, so convert .eps files to .pdf
\usepackage[pdftex]{graphicx}
\usepackage{epstopdf}
\fi
   
% Declare some variables to hold the text fields 

    \newcommand{\Title}[1]{\gdef\SGUField@Title{#1}}
    \newcommand{\Protitle}[1]{\gdef\SGUField@Protitle{#1}}
    \newcommand{\deptname}[1]{\gdef\SGUField@deptname{#1}}
    \newcommand{\dept}[1]{\gdef\SGUField@dept{#1}}
    \newcommand{\degree}[1]{\gdef\SGUField@degree{#1}}
    \newcommand{\university}[1]{\gdef\SGUField@university{#1}}
    \newcommand{\MemberA}[1]{\gdef\SGUField@MemberA{#1}}
    \newcommand{\MemberB}[1]{\gdef\SGUField@MemberB{#1}}
    \newcommand{\MemberC}[1]{\gdef\SGUField@MemberC{#1}}
    \newcommand{\MemberD}[1]{\gdef\SGUField@MemberD{#1}}
    \newcommand{\RegA}[1]{\gdef\SGUField@RegA{#1}}
    \newcommand{\RegB}[1]{\gdef\SGUField@RegB{#1}}
    \newcommand{\RegC}[1]{\gdef\SGUField@RegC{#1}}
    \newcommand{\RegD}[1]{\gdef\SGUField@RegD{#1}}
    \newcommand{\Year}[1]{\gdef\SGUField@Year{#1}}
    \newcommand{\Month}[1]{\gdef\SGUField@Month{#1}}
    \newcommand{\Guidename}[1]{\gdef\SGUField@Guidename{#1}}   
    \newcommand{\Hodname}[1]{\gdef\SGUField@Hodname{#1}}   
    \newcommand{\Deanname}[1]{\gdef\SGUField@Deanname{#1}}   
    \newcommand{\Collegename}[1]{\gdef\SGUField@Collegename{#1}}
    \newcommand{\Certificate}[1]{\gdef\SGUField@Certificate{#1}}

% Code for printing month
     \usepackage{ifthen}
     \newcommand{\monthnum}[1]%
{%
\ifthenelse{\equal{#1}{1}}{\Month{January}}{}%
\ifthenelse{\equal{#1}{2}}{\Month{February}}{}%
\ifthenelse{\equal{#1}{3}}{\Month{March}}{}%
\ifthenelse{\equal{#1}{4}}{\Month{April}}{}%
\ifthenelse{\equal{#1}{5}}{\Month{May}}{}%
\ifthenelse{\equal{#1}{6}}{\Month{June}}{}%
\ifthenelse{\equal{#1}{7}}{\Month{July}}{}%
\ifthenelse{\equal{#1}{8}}{\Month{August}}{}%
\ifthenelse{\equal{#1}{9}}{\Month{September}}{}%
\ifthenelse{\equal{#1}{10}}{\Month{October}}{}%
\ifthenelse{\equal{#1}{11}}{\Month{November}}{}%
\ifthenelse{\equal{#1}{12}}{\Month{December}}{}%
}

% Initialize the variables to their default values

    \Title{\textit{A \\ Dissertation Report on\\}}
    \Protitle{}\\[\baselineskip]       
    \deptname{\textcolor[rgb]{0.65,0.16,0}{Electronics  Engineering}}
    \dept{\textcolor[rgb]{1,0,0}{DEPARTMENT OF  ELECTRONICS ENGINEERING}}
    \degree{\textcolor[rgb]{0.65,0.16,0}{Doctor of Philosophy}}
    \MemberA{} \MemberB{} \MemberC{} \MemberD{}
    \RegA{} \RegB{} \RegC{} \RegD{}
    \Year{\number \year}
    \Guidename{}
    \Collegename{\textcolor[rgb]{0.65,0.16,0}{{\textbf {SANJAY GHODAWAT UNIVERSITY, KOLHAPUR\\[0.2cm]{\footmotesize \textcolor[rgb]{0,0,0.55} {This Project is Sponsored by\\ The Institution of Engineers (India) \\Kolkata}}}}}}
    \Certificate{CERTIFICATE}
    \university{\textcolor[rgb]{0.65,0.16,0}{{\textbf {SANJAY GHODAWAT UNIVERSITY,\\ KOLHAPUR}}}}
   \monthnum{1}

% Define the preliminary page layouts using the variables

% Defining title page
    \newcommand{\SGUtitlepage}{
        \thispagestyle{empty}
        {  
        \centering
        \providecommand\pdfbookmark[3][]{} \pdfbookmark[0]{Title Page}{bm:Title}
      \parbox[t]{6in}{\centering \Large\SGUField@Title} \\[\baselineskip]       
      \LARGE{\textbf{\SGUField@Protitle}} \\[\baselineskip] \normalsize
      \Large
      %\vspace{0.1cm}
      \textit{Submitted by}
%\begin{table}[h]
%\centering
%\begin{tabular}{lr}
\textbf{\Large{\SGUField@MemberA}} \\ \textit{\textbf{\Large{\SGUField@RegA}}} \tabularnewline
\textbf{\Large{\SGUField@MemberB}} \\ \textit{\textbf{\Large{\SGUField@RegB}}} \tabularnewline
\textbf{\Large{\SGUField@MemberC}} \\ \textit{\textbf{\Large{\SGUField@RegC}}} \tabularnewline
\textbf{\Large{\SGUField@MemberD}}\\ \textit{\textbf{\Large{\SGUField@RegD}}} \tabularnewline 
%\end{tabular}
%\end{table}

 \vspace{0.1cm}

 \textit{Under The Guidance of} \linebreak
        \textbf{\textup{\SGUField@Guidename}} \\[\baselineskip]
 \vspace{0.1cm}
      \textit{For The Award of The Degree of}\\[\baselineskip]
      %\vspace{0.1cm}
      \textbf{\SGUField@degree} \linebreak
      \textit{in} \linebreak
      \textbf{ \SGUField@deptname} \\[\baselineskip]

       % \vspace{0.1cm}
        \includegraphics[width=0.12 \textwidth]{SGU_Logo}\\[\baselineskip]
        %\vspace{0.1cm}
        \SGUField@dept \linebreak
        \SGUField@Collegename \linebreak
        \mbox{\SGUField@Month \hspace{0.1cm} \SGUField@Year} \\[\baselineskip]
        }
        \clearemptydoublepage
      }

% Defining certificate page

      \newcommand{\SGUcertificatepage}{
        \thispagestyle{empty}
        {\centering
%     \SGUField@dept \\ \linebreak
%\vspace{0.2cm}
        %\SGUField@Collegename \linebreak
        \providecommand\pdfbookmark[3][]{} \pdfbookmark[0]{CertificatePage}{bm:Certificate}
        \parbox[t]{6in}{\centering \Large{\underline{\SGUField@Certificate}}\par}\\[\baselineskip] 
      \normalsize \large
      The report titled \linebreak
      \LARGE{\textbf{\SGUField@Protitle}} \\[\baselineskip] \normalsize \large
      \textit{duly completed by}\\ %[\baselineskip]      
\textbf{\Large{\SGUField@MemberA}} \\ \textit{\textbf{\Large{\SGUField@RegA}}} \tabularnewline
\textbf{\Large{\SGUField@MemberB}} \\ \textit{\textbf{\Large{\SGUField@RegB}}} \tabularnewline
\textbf{\Large{\SGUField@MemberC}} \\ \textit{\textbf{\Large{\SGUField@RegC}}} \tabularnewline
\textbf{\Large{\SGUField@MemberD}}\\ \textit{\textbf{\Large{\SGUField@RegD}}} \tabularnewline 

\vspace{0.5cm}

       \textit{as a partial fulfillment of the \\ requirements for the degree of}\\[\baselineskip]
       \textbf{\SGUField@degree} \linebreak
       \textit{in} \linebreak
       \textbf{\SGUField@deptname} \\[\baselineskip]
       \textit{from} \linebreak  
       \textbf{\SGUField@university}
%\vfill
\vspace{1.0cm}

\begin{table}[h]
\centering
\begin{tabular}{ccc}
\large{\SGUField@Guidename}  &\hspace{0.6cm}&  \large{\SGUField@Hodname}\\[0.1cm]
 \large{\textit {Supervisor}} &\hspace{0.6cm}&   \large{\textit {Head of Department}} \\[1.8cm]
\large{\SGUField@Deanname}  &\hspace{0.6cm}&  \\[0.1cm]
\large{\textit {Academic Dean}} &\hspace{0.6cm}&  \large{\textit {External Examiner} }
 \end{tabular}
 \end{table}

%\begin{table}[h]
%\centering
%\begin{tabular}{ccc}
%\tabularnewline \tabularnewline \tabularnewline
%\large{\SGUField@Guidename}  & \hspace*{1.0cm} \large{\SGUField@Hodname}
%} 
%\tabularnewline \tabularnewline \tabularnewline
% \large{Project Guide} &   \large{Head of Department} 
%\tabularnewline \tabularnewline \tabularnewline \tabularnewline \tabularnewline
%\large{Academic Dean} &  \large{External Examiner} 
%\tabularnewline
% \end{tabular}
% \end{table}
\begin{flushleft}
Date: \today\\
Place: {\begin{center}\SGUField@dept, \\
\hspace{1.0cm} \SGUField@university
\end{center}}


%To print sponsored by replace @university with @Collegename

\end{flushleft} 
       }
       \clearemptydoublepage
      }
        
% Define the macro for making preliminary pages

     \newcommand{\makepreliminarypages}{
        \singlespace
        \changepage{0.8in}{}{}{}{}{}{-0.2in}{-0.3in}{}
        \SGUtitlepage
        \SGUcertificatepage
        \renewcommand{\clearemptydoublepage}{\cle@remptydoublep@ge}   
        \changepage{-0.5in}{}{}{}{}{}{0.2in}{0.3in}{}
        \doublespace
    }

    \usepackage{xifthen} % Default Argument is Empty
    % \newcommand{\optarg}[1]{\ifthenelse{\isempty{#1}}{}{#1}}
    
    % College name is other than Sanjay Ghodawat Univresity
    \newcommand{\College}[1]{\ifthenelse{\isempty{#1}}{}{\Collegename{#1}}}
    
    % Department name is other than Electronics and Telecommunication Engineering
    \newcommand{\Department}[1]{\ifthenelse{\isempty{#1}}{}{\deptname{#1} \dept{#1}}}

    % Degree name is other than Bachelor of Engineering
    \newcommand{\Degree}[1]{\ifthenelse{\isempty{#1}}{}{\degree{#1}}}

    % University name is other than University of Solapur
    \newcommand{\University}[1]{\ifthenelse{\isempty{#1}}{}{\university{#1}}}


% A command to handle single sided preliminary pages in a double sided environment

% Define the '\clearemptydoublepage' command to clear pages but not number any blank pages inserted.
    \let\cle@rdoublep@ge\cleardoublepage
    \newcommand{\cle@remptydoublep@ge}{
      \clearpage
      \if@twoside
      \ifodd\c@page\else
      \fi\fi
      {\pagestyle{empty}\cle@rdoublep@ge}}
    \newcommand{\clearemptydoublepage}{\cle@remptydoublep@ge}

% Load the class and needed packages
    \DeclareOption*{\PassOptionsToClass{\CurrentOption}{book}}
    \ProcessOptions
    \relax
    \LoadClass[a4paper,12pt,oneside]{book}
    \RequirePackage{changepage}

% A couple of useful macros for line spacing

% The \singlespace macro switches to single spaced lines
\newcommand{\singlespace}{\par\renewcommand{\baselinestretch}{1}\small\normalsize\par}

% The \doublespace macro switches to double spaced lines
\newcommand{\doublespace}{\par\renewcommand{\baselinestretch}{1.66}\small\normalsize\par}

% This package allows you to specify the 4 margins without needing to remember the particular page dimensions commands
\usepackage[top=1.4in, bottom=1.4in, left=1.3in, right=1.1in]{geometry}

% Redefine the Table of Contents to deal with some blank page
% and bookmarking issues relating to ETD submission
    \let\TEMPtableofcontents\tableofcontents
    \renewcommand{\tableofcontents}{
      \clearemptydoublepage
      \singlespace
      \providecommand\phantomsection{} \phantomsection
      \addcontentsline{toc}{chapter}{Table of Contents}
      \TEMPtableofcontents
      \clearemptydoublepage
      \doublespace
    }

% Redefine the List of Figures to deal with some blank page
% and bookmarking issues
    \let\TEMPlistoffigures\listoffigures
    \renewcommand{\listoffigures}{
      \providecommand\phantomsection{} \phantomsection
      \addcontentsline{toc}{chapter}{List of Figures}
      \TEMPlistoffigures
    }

% Redefine the Bibliography to deal with a bookmarking issues
    \let\TEMPbibliography\bibliography
    \renewcommand{\bibliography}{\clearemptydoublepage
      \providecommand\phantomsection{} \phantomsection
      \addcontentsline{toc}{chapter}{References}
      \TEMPbibliography
    }

% These packages typeset the thesis with Times Roman font
\usepackage[T1]{fontenc}
\usepackage{mathptmx}

% The fancyhdr package allows to easily customize page header.
% The settings below produce a nice, well separated header.
\usepackage{fancyhdr}
  \fancyhead{}
  \fancyhead[RO,RE]{\slshape \rightmark}
  \fancyfoot{}
  \fancyfoot[CO,CE]{\thepage}
  \pagestyle{fancy}
  \renewcommand{\chaptermark}[1]{\markboth{\chaptername \ \thechapter \ \ #1}{}}
  \renewcommand{\sectionmark}[1]{\markright{\thesection \ \ #1}}

% The caption package allows you to change the formatting of figure captions.
% The commands here change to the suggested caption format:
% single spaced and a bold tag
\usepackage[margin=0.3in,labelfont=bf,labelsep=none]{caption}
 \DeclareCaptionFormat{suggested}{\singlespace#1#2 #3\par\doublespace}
 \captionsetup{format=suggested}

% The hyperref package provides automatic linking and
% bookmarking for the table of contents, index, equation
% references, and figure references.  It must be included for
% the SGU class to make a properly functioning
% electronic thesis.  It should be the last package loaded if
% possible.
%
% To add a bookmark in the pdf you can use \pdfbookmark.  
% You can look up its usage in hyperref package documentation
\usepackage[bookmarksnumbered,pdfpagelabels=true,plainpages=false,colorlinks=true,linkcolor=black,citecolor=black,urlcolor=blue]{hyperref}
\urlstyle{rm}
\doublespace